#ifndef _WWRIFF_H
#define _WWRIFF_H

#define __STDC_CONSTANT_MACROS
#include <string>
#include <iostream>
#include <fstream>
#include "stdint.h"
#include "errors.h"

using namespace std;

class Wwise_RIFF_Vorbis
{
    string _file_name;
    ifstream _infile;
    long _file_size;

    bool _little_endian;

    long _fmt_offset, _vorb_offset, _data_offset;
    long _fmt_size, _vorb_size, _data_size;

    // RIFF fmt
    uint16_t _channels;
    uint32_t _sample_rate;
    uint32_t _avg_bytes_per_second;

    // RIFF extended fmt
    uint16_t _ext_unk;

    // vorbis info
    uint32_t _sample_count;
    uint32_t _setup_packet_offset;
    uint32_t _first_audio_packet_offset;
    uint32_t _uid;
    uint8_t _blocksize_0_pow;
    uint8_t _blocksize_1_pow;

public:
    Wwise_RIFF_Vorbis(const string& name);

    void print_info(void);

    void generate_ogg(ofstream& of);
};

#endif
